﻿Lintalist: Searchable interactive lists to copy & paste text, run scripts, using easily exchangeable bundles - http://lintalist.github.io/
(snippet manager, text expander)

# Introduction

Lintalist allows you to store and (incrementally) **search** and **edit texts**
in bundles and **paste** a selected text in your active program. The text **can**
be interactive, for example, you can automatically insert the current time and
date, ask for (basic) user input or make a selection from a list etc. 

AutoHotkey.com forum thread: https://autohotkey.com/boards/viewtopic.php?f=6&t=3378

Other features:

* Assign keyboard shortcuts to your favourite Snippets
* Use abbreviations (shorthand) for your favourite Snippets
* Run scripts which can be included in a Bundle
* Use the standard Plugins (date, variables, counters, clipboard etc) or develop your own
* Read more in the documentation...

Lintalist is open source and developed in [AutoHotkey](https://autohotkey.com/),
an easy to learn scripting language for Windows (WinXP and above)

__Lintalist search window__

![Lintalist search window](https://raw.github.com/lintalist/lintalist/master/docs/img/lintalist-search.png)

1. Type query (multiple search modes)
2. Menu + search options.
3. Result list with Part 1, Part 2, Key(board shortcut), Short(hand, abbreviation). Columns are dynamic, if part 2, key or short are not present in the loaded bundle(s) they will not be displayed.
4. Preview of top most or selected snippet text. In statusbar: loaded bundle(s) and hits / number of snippets.

# Installation

1. New users: Download the [lastest release](https://github.com/lintalist/lintalist/releases) - unpack to a new directory and run lintalist.exe (or lintalist.ahk if you are already an AutoHotkey user)
2. AutoHotkey users (or installing updates): Download the [master.zip](https://github.com/lintalist/lintalist/archive/master.zip) - unpack to a new (or your current Lintalist) directory and run lintalist.ahk or lintalist.exe

# More information

More about Lintalist in "docs\index.html" after you downloaded it, right click on the tray icon (Help) or
visit <http://lintalist.github.io/>

# Videos

* Introduction: <http://youtu.be/XfjZPAhHB8c>
* HTML/Markdown: <http://youtu.be/Q6SFkttjUQk>
* Formatted text: <http://youtu.be/J1StUarGHmI>
* Plugins: <http://youtu.be/Rtd_ChyRVkM>

# AutoHotkey

Lintalist is written in AutoHotkey, a free and open-source utility for Windows. You can 
learn more about AutoHotkey at <http://autohotkey.com/>. The source code for AutoHotkey 
is available at <https://github.com/Lexikos/AutoHotkey_L>

**Note**: lintalist.exe is simply a renamed autohotkey.exe included for convenience.
This script requires a working copy of autohotkey.exe to be present in order to run
user scripts defined in bundles. If you have AHK installed you can safely delete
lintalist.exe and just start lintalist.ahk directly.

### Elsewhere

* [AutoHotkey.com](https://autohotkey.com/boards/viewtopic.php?f=6&t=3378)
* [Portablefreeware.com](http://www.portablefreeware.com/index.php?id=2686)
* [DonationCoder.com](http://www.donationcoder.com/forum/index.php?topic=41475)
* [Alternativeto.net](http://alternativeto.net/software/lintalist/)

### Credits

Lintalist uses various libraries, icons and more prepared by others - see [credits.txt](https://github.com/lintalist/lintalist/blob/master/docs/credits.txt) for a complete list (if something is missing do let me know)

Copyright 2009-2020 Lintalist. See license.txt